/*
*  gpg.cpp 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver AAM grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "gpg.h"
#include "gpgme.h"
#include "gnupg.h"
#include "global.h"
#include "utility.h"
#include "t-support.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
HINSTANCE hGPGMeLib = NULL;
//---------------------------------------------------------------------------

AnsiString __fastcall GPGMeDir()
{
   return AppDir();
}
//---------------------------------------------------------------------------

AnsiString __fastcall GPGMeDll()
{
   return GPGMeDir()+"libgpgme-11.dll";
}
//---------------------------------------------------------------------------

bool __fastcall InitGPGMeLibrary()
{
   AnsiString gpgmedll = ExtractFileName(GPGMeDll());

   if (!FileExists(GPGMeDll()))
   {
	  MsgBox(Application->MainForm,
		 "Problem! The file " + gpgmedll + " is missing from my home   \n"
		 "directory. I can't continue. Reinstalling the program   \n"
		 "should solve the problem.",
		  MT_ERROR, MB_OK);
	  return false;
   }

   if (!FileExists(GPGExe()))
   {
	  MsgBox(Application->MainForm,
		 "Problem! The file gpg.exe is missing from my home   \n"
		 "directory. I can't continue. Reinstalling the program   \n"
		 "should solve the problem.",
		  MT_ERROR, MB_OK);
	  return false;
   }

   if (!FileExists(GPGConf()))
   {
	  MsgBox(Application->MainForm,
		 "Problem! The file gpg.conf is missing from the gpg data  \n"
		 "directory. I can't continue. Reinstalling the program   \n"
		 "should solve the problem.",
		  MT_ERROR, MB_OK);
	  return false;
   }

   hGPGMeLib = LoadLibrary(GPGMeDll().c_str());
   if (!hGPGMeLib)
   {
	  MsgBox(Application->MainForm,
		 "Failed to load "+ gpgmedll + "! "
		 "The error reported was:   \n" +
		  GetLastErrorStr(),
		  MT_ERROR, MB_OK);
	  return false;
   }

   return true;
}
//---------------------------------------------------------------------------

/*void __fastcall init_gpgme (gpgme_protocol_t proto)
{
  gpgme_error_t err;

  gpgme_check_version (NULL);
  setlocale (LC_ALL, "");
  gpgme_set_locale (NULL, LC_CTYPE, setlocale (LC_CTYPE, NULL));
#ifndef HAVE_W32_SYSTEM
  gpgme_set_locale (NULL, LC_MESSAGES, setlocale (LC_MESSAGES, NULL));
#endif

  err = gpgme_engine_check_version (proto);
  fail_if_err (err);
}*/
gpgme_error_t passphrase_cb (void *opaque, const char *uid_hint, const char *passphrase_info,
		   int last_was_bad, int fd)
{
sm("OK");
  DWORD written;
  WriteFile ((HANDLE)fd, "panties\n", 4, &written, 0);
  return 0;
}
//---------------------------------------------------------------------------

bool __fastcall GPGMEDecryptVerifyMessage(TForm *Owner, TStrings *Message,
   AnsiString &Passphrase)
{
  gpgme_ctx_t ctx;
  gpgme_error_t err;
  gpgme_data_t in, out;
  gpgme_decrypt_result_t result;
  const char *cipher_1_asc = make_filename ("cipher-1.asc");
  char *agent_info;

  //init_gpgme (GPGME_PROTOCOL_OpenPGP);
  gpgme_check_version (NULL);

  err = gpgme_new (&ctx);
  fail_if_err (err);

  agent_info = getenv("GPG_AGENT_INFO");
  if (!(agent_info && strchr (agent_info, ':')))
	gpgme_set_passphrase_cb (ctx, passphrase_cb, NULL);

  AnsiString data = Message->Text;
  err = gpgme_data_new_from_mem (&in, data.c_str(), data.Length(), 1);
  fail_if_err (err);

  err = gpgme_data_new (&out);
  fail_if_err (err);

  err = gpgme_op_decrypt (ctx, in, out);
  fail_if_err (err);
sm(err);
/*
  result = gpgme_op_decrypt_result (ctx);
  if (result->unsupported_algorithm)
	{
	  fprintf (stderr, "%s:%i: unsupported algorithm: %s\n",
		   __FILE__, __LINE__, result->unsupported_algorithm);
	  exit (1);
	}
  print_data (out);

  gpgme_data_release (in);
  gpgme_data_release (out);
  gpgme_release (ctx);
  */
  return false;
}
//---------------------------------------------------------------------------

/*const char *gpgme_check_version (const char *req_version)
{
   GPGMECHECKVERSION chkver = (GPGMECHECKVERSION)GetProcAddress(hGPGMeLib, "gpgme_check_version");
   assert(chkver);
}*/
//---------------------------------------------------------------------------

const char *gpgme_check_version_internal (const char *req_version, size_t offset_sig_validity)
{
   GPGMECHECKVERSIONINTERNAL chkver =
	  (GPGMECHECKVERSIONINTERNAL)GetProcAddress(hGPGMeLib, "gpgme_check_version_internal");
   assert(chkver);
   AnsiString ver = (chkver)(req_version, offset_sig_validity);
   return ver.c_str();
}
//---------------------------------------------------------------------------

gpgme_error_t gpgme_new (gpgme_ctx_t *ctx)
{
   GPGMENEW gpgmenew = (GPGMENEW)GetProcAddress(hGPGMeLib, "gpgme_new");
   assert(gpgmenew);
   return (gpgmenew)(ctx);
}
//---------------------------------------------------------------------------

const char *gpgme_strerror (gpgme_error_t err)
{
   GPGMESTRERROR strerr = (GPGMESTRERROR)GetProcAddress(hGPGMeLib, "gpgme_strerror");
   assert(strerr);
   return (strerr)(err);
}
//---------------------------------------------------------------------------

const char *gpgme_strsource (gpgme_error_t err)
{
   GPGMESTRSOURCE strsrc = (GPGMESTRERROR)GetProcAddress(hGPGMeLib, "gpgme_strsource");
   assert(strsrc);
   return (strsrc)(err);
}
//---------------------------------------------------------------------------

void gpgme_set_passphrase_cb (gpgme_ctx_t ctx, gpgme_passphrase_cb_t cb, void *hook_value)
{
   GPGMESETPASSPHRASECB setcb = (GPGMESETPASSPHRASECB)GetProcAddress(hGPGMeLib, "gpgme_set_passphrase_cb");
   assert(setcb);
   setcb(ctx, cb, hook_value);
}
//---------------------------------------------------------------------------

gpgme_error_t gpgme_data_new_from_mem (gpgme_data_t *r_dh, const char *buffer, size_t size, int copy)
{
   GPGMEDATANEWFROMMEM newdata = (GPGMEDATANEWFROMMEM)GetProcAddress(hGPGMeLib, "gpgme_data_new_from_mem");
   assert(newdata);
   return (newdata)(r_dh, buffer, size, copy);
}
//---------------------------------------------------------------------------

gpgme_error_t gpgme_data_new (gpgme_data_t *r_dh)
{
   GPGDATANEW newdata = (GPGDATANEW)GetProcAddress(hGPGMeLib, "gpgme_data_new");
   assert(newdata);
   return (newdata)(r_dh);
}
//---------------------------------------------------------------------------

gpgme_error_t gpgme_op_decrypt (gpgme_ctx_t ctx, gpgme_data_t cipher, gpgme_data_t plain)
{
   GPGMEOPDECRYPT opdec = (GPGMEOPDECRYPT)GetProcAddress(hGPGMeLib, "gpgme_op_decrypt");
   assert(opdec);
   return (opdec)(ctx, cipher, plain);
}
//---------------------------------------------------------------------------

