/*
*  mainwins.h 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver AAM grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------
#ifndef mainwinsH
#define mainwinsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <Buttons.hpp>
#include <ImgList.hpp>
#include "msgmans.h"
#include "global.h"
//---------------------------------------------------------------------------

class TQSAMainWin : public TForm
{
__published:	// IDE-managed Components
	TMainMenu *MainMenu;
	TMenuItem *FileMenu;
	TMenuItem *FileExitItem;
	TMenuItem *FileGetMailItem;
	TMenuItem *N2;
	TPanel *ToolBar;
	TListView *ListView;
	TSplitter *Splitter;
	TStatusBar *StatusBar;
	TBevel *Bevel1;
	TSpeedButton *GetBtn;
	TBevel *Bevel7;
	TComboBox *ProxyBox;
	TLabel *Label1;
	TTimer *Timer1;
	TMenuItem *ToolsMenu;
	TMenuItem *HelpMenu;
	TMenuItem *HelpTopicsItem;
	TMenuItem *ToolsAccountsItem;
	TMenuItem *ToolsProxiesItem;
	TCheckBox *Subjects;
	TLabel *Label2;
	TMenuItem *HelpAboutItem;
	TMenuItem *N3;
	TMenuItem *Openini1;
	TPopupMenu *PopupMenu1;
	TPopupMenu *PopupMenu2;
	TMenuItem *Popup1DeleteItem;
	TMenuItem *Popup2CopyItem;
	TMenuItem *Popup2SelectallItem;
	TMenuItem *Catchupnewsgroup1;
	TMenuItem *N7;
	TMenuItem *Options1;
	TMenuItem *N9;
	TMenuItem *Popup1DecryptItem;
	TMenuItem *N10;
	TSpeedButton *CopyBtn;
	TSpeedButton *DecryptBtn;
	TSpeedButton *DeleteBtn;
	TBevel *Bevel2;
	TBevel *Bevel3;
	TMenuItem *EditMenu;
	TMenuItem *EditCopyItem;
	TMenuItem *ToolsDeletemessageItem;
	TMenuItem *EditSelectallItem;
	TMenuItem *ToolsDecryptmessageItem;
	TMenuItem *Popup2DeletemessageItem;
	TMenuItem *Popup1SelectallItem;
	TMenuItem *Popup2DecryptmessageItem;
	TMenuItem *N8;
	TMenuItem *N5;
	TImageList *ImageList1;
	TComboBox *ServerBox;
	TSpeedButton *CopyMsgBtn;
	TMenuItem *Popup1OpenItem;
	TMenuItem *FileOpenItem;
	TMenuItem *Copymessagetoclipboard1;
	TMenuItem *N4;
	TPopupMenu *TrayMenu;
	TMenuItem *TrayMenuRestoreItem;
	TMenuItem *TrayMenuExitItem;
	TTimer *CheckMailTimer;
	TMenuItem *ToolsSubjectsItem;
	TMenuItem *N6;
	TMenuItem *HelpHistoryItem;
	TMenuItem *N12;
	TMenuItem *Messages1;
	TMenuItem *View1;
	TMenuItem *Nntplog1;
	TMenuItem *Open1;
	TMenuItem *Applicationdirectory1;
	TMenuItem *Selectedmessages1;
	TMenuItem *N13;
	TMenuItem *Commandprompt1;
	TMenuItem *Applicationdatadirectory1;
	TTimer *Timer3;
	TPanel *Panel1;
	TTabControl *TabControl;
	TRichEdit *Log;
	TRichEdit *Message;
	TRichEdit *Status;
	TTimer *Timer4;
	TSpeedButton *SpeedButton1;
	TTimer *StartTimer;
	TMenuItem *Clipboard1;
	TMenuItem *Recieve1;
	TMenuItem *FileSecuremode;
	TMenuItem *PGPkeyrings1;
	TTimer *Timer2;
	TTimer *Timer6;
	TImageList *TrayIcons;
	TMenuItem *N1;
	TMenuItem *FileSavedatabase;
	TMenuItem *Nymservers1;
	TMenuItem *N11;
	TMenuItem *N14;
	TMenuItem *Save1;
	TMenuItem *Popup2CopyMessageToClipboard;
	TMenuItem *Popup1CopyMessageToClipboard;
	TMenuItem *ToolsConfigmessages;
	TMenuItem *qsaserverstxt1;
	TMenuItem *N15;
	TTimer *NNTPTimeoutTimer;
	TMenuItem *Composenewmessage1;
	TMenuItem *N16;
	TCheckBox *FewerHeaders;
	TMenuItem *Fewerheaders1;
	void __fastcall FileExitItemClick(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall FileGetMailItemClick(TObject *Sender);
	void __fastcall FileMenuClick(TObject *Sender);
	void __fastcall SubjectsClick(TObject *Sender);
	void __fastcall HelpAboutItemClick(TObject *Sender);
	void __fastcall Openini1Click(TObject *Sender);
	void __fastcall Popup1DeleteItemClick(TObject *Sender);
	void __fastcall PopupMenu1Popup(TObject *Sender);
	void __fastcall ToolsAccountsItemClick(TObject *Sender);
	void __fastcall PopupMenu2Popup(TObject *Sender);
	void __fastcall Popup2SelectallItemClick(TObject *Sender);
	void __fastcall EditCopyItemClick(TObject *Sender);
	void __fastcall MessageSelectionChange(TObject *Sender);
	void __fastcall EditMenuClick(TObject *Sender);
	void __fastcall Popup1SelectallItemClick(TObject *Sender);
	void __fastcall EditSelectallItemClick(TObject *Sender);
	void __fastcall ToolsMenuClick(TObject *Sender);
	void __fastcall ToolsProxiesItemClick(TObject *Sender);
	void __fastcall Catchupnewsgroup1Click(TObject *Sender);
	void __fastcall ProxyBoxSelect(TObject *Sender);
	void __fastcall ComboBoxDropDown(TObject *Sender);
	void __fastcall ComboBoxCloseUp(TObject *Sender);
	void __fastcall ServerBoxSelect(TObject *Sender);
	void __fastcall ToolsDeletemessageItemClick(TObject *Sender);
	void __fastcall ToolsDecryptmessageItemClick(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall Options1Click(TObject *Sender);
	void __fastcall Copymessagetoclipboard1Click(TObject *Sender);
	void __fastcall TrayMenuRestoreItemClick(TObject *Sender);
	void __fastcall TrayMenuExitItemClick(TObject *Sender);
	void __fastcall ListViewKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall ToolsSubjectsItemClick(TObject *Sender);
	void __fastcall HelpHistoryItemClick(TObject *Sender);
	void __fastcall HelpMenuClick(TObject *Sender);
	void __fastcall Messages1Click(TObject *Sender);
	void __fastcall Nntplog1Click(TObject *Sender);
	void __fastcall Applicationdirectory1Click(TObject *Sender);
	void __fastcall Applicationdatadirectory1Click(TObject *Sender);
	void __fastcall Commandprompt1Click(TObject *Sender);
	void __fastcall Open1Click(TObject *Sender);
	void __fastcall StatusBarDrawPanel(TStatusBar *StatusBar, TStatusPanel *Panel,
		  const TRect &Rect);
	void __fastcall TabControlChange(TObject *Sender);
	void __fastcall StatusSelectionChange(TObject *Sender);
	void __fastcall Copy1Click(TObject *Sender);
	void __fastcall Selectall1Click(TObject *Sender);
	void __fastcall Popup2CopyItemClick(TObject *Sender);
	void __fastcall Timer4Timer(TObject *Sender);
	void __fastcall SpeedButton1Click(TObject *Sender);
	void __fastcall StatusBarMouseDown(TObject *Sender, TMouseButton Button,
		  TShiftState Shift, int X, int Y);
	void __fastcall StartTimerTimer(TObject *Sender);
	void __fastcall CheckMailTimerTimer(TObject *Sender);
	void __fastcall HelpTopicsItemClick(TObject *Sender);
	void __fastcall FileSecuremodeClick(TObject *Sender);
	void __fastcall PGPkeyrings1Click(TObject *Sender);
	void __fastcall Timer2Timer(TObject *Sender);
	void __fastcall Timer6Timer(TObject *Sender);
	void __fastcall FileSavedatabaseClick(TObject *Sender);
	void __fastcall Nymservers1Click(TObject *Sender);
	void __fastcall ListViewSelectItem(TObject *Sender, TListItem *Item,
          bool Selected);
	void __fastcall ListViewDblClick(TObject *Sender);
	void __fastcall Save1Click(TObject *Sender);
	void __fastcall ToolsConfigmessagesClick(TObject *Sender);
	void __fastcall qsaserverstxt1Click(TObject *Sender);
	void __fastcall NNTPTimeoutTimerTimer(TObject *Sender);
	void __fastcall Composenewmessage1Click(TObject *Sender);
	void __fastcall View1Click(TObject *Sender);
	void __fastcall FewerHeadersClick(TObject *Sender);
	void __fastcall Fewerheaders1Click(TObject *Sender);
private:	// User declarations
	NOTIFYICONDATA iconinfo;
	void __fastcall WndProc(Messages::TMessage &Message);
	void __fastcall AppMessage(tagMSG &Msg, bool &Handled);
public:		// User declarations
	AnsiString cap, orgwin, nntpproxy, newsgroup, account, curmsgkey, prvmsgkey;
	TStringList *data, *profile, *mail, *error;
	bool trayed, hideprxy, hidehost, bailout, firstrun, checkmail, goterror,
	   needspack, runminimized, usetray, savedecrypted;
	TStatusPanel *ProgressPanel;
	TMsgManager *msgman;
	int traymails, LastErr, flashcount, progresspcnt;
	//AnsiString pbText;
	TIcon *trayicon;
	int trayiconidx;
	int checkmailmins, checkminselapsed;
	__fastcall TQSAMainWin(TComponent* Owner);
	__fastcall virtual ~TQSAMainWin();
	void __fastcall Display(const AnsiString &msg);
	void __fastcall DisplayLast(const AnsiString &msg);
	void __fastcall LoadProfile(const AnsiString &name, TStrings *profile);
	void __fastcall SaveProfile(const AnsiString &name, TStrings *Profile);
	//AnsiString __fastcall QSADefaultsFile();
	void __fastcall LoadIni(bool startup);
	bool __fastcall LoadESUB32Dll();
	void __fastcall LoadAccountsMenu();
	void __fastcall LoadProxyBox();
	void __fastcall LoadServerBox();
	void __fastcall LoadListView();
	void __fastcall LoadListItem(TListItem *item, const AnsiString &msgkey, TStrings *msg);
	AnsiString __fastcall GetNymAndTypeHeader(const AnsiString &CurMsgKey);

	//bool __fastcall CheckStartupInfoMinimized();
	void __fastcall CheckReportDefaultProxyMissing();
	void __fastcall CheckReportDefaultServerMissing();
	bool __fastcall CheckNoSubjectsDefined();
	bool __fastcall CheckAllFilesPresent();
	bool __fastcall CheckKeyringsDefined();
	bool __fastcall CheckInstallLocationOk();
	bool __fastcall CheckInstallNymservers();
	//bool __fastcall CheckNotifyQSLClipboard(TStrings *msg);
	//bool __fastcall CheckNotifyQSLClipboardOrCopyData(TStrings *msg);
	bool __fastcall CheckFixMessageNotSelected();
	//bool __fastcall CompactMessageHeaders(TStrings *msg);
	bool __fastcall GetKeyringPathnames(const AnsiString &gpgconf, AnsiString &secring, AnsiString &pubring);
	bool __fastcall IsStandAloneProgFilesInstall();
	void __fastcall EnableToolbar(bool enable);
	void __fastcall SaveMessage(int msgno, TStrings *msg);
	void __fastcall ShowStatus(const AnsiString &msg);
	void __fastcall ShowRecords(const int count);
	void __fastcall ShowProgress(const short percent);
	void __fastcall DeleteSelectedMessages();
	void __fastcall AccountsItemClick(TObject *Sender);
	void __fastcall ClearListViewSelected();
	void __fastcall SetupToolbar();
	void __fastcall SetupStatusBar();
	void __fastcall SetCaption();
	bool __fastcall WantsDecrypt();
	int  __fastcall FindMessageKey(const AnsiString &subkey);

	//void __fastcall DecryptMessages(int count);
	void __fastcall MarkMessageRead(const int index);
	void __fastcall SaveMessageDecrypted(TStrings *msg);
	bool __fastcall IsMessageRead(const AnsiString &msgkey);
	//bool __fastcall NeedsDecryptVerify(TStrings *msg);
	int  __fastcall DownloadPercentComplete(WORD next, DWORD total);
	void __fastcall SetPage(const AnsiString &TabText);
	bool __fastcall HasTab(const AnsiString &TabText);
	void __fastcall CheckFixIdeaDllInGPGConf();
	bool __fastcall IsActiveTab(const AnsiString &TabText);
	AnsiString __fastcall GetSecondSubject(TStrings *msg);
	AnsiString __fastcall GetSubject(TStrings *msg);
	AnsiString __fastcall GetFrom(TStrings *msg);
	TStrings* __fastcall ObjMessage(int index);
	void __fastcall TrayIcon_Modify(int iconIdx, const AnsiString &tipText);
	void __fastcall TrayIcon_Create(int iconidx);
	void __fastcall TrayIcon_Delete();
	// message functions
	//void virtual __fastcall WMLoadPreview(TMessage& Msg);
	//void virtual __fastcall WMSaveProfile(TMessage& Msg);
	void virtual __fastcall WMSaveMessage(TMessage& Msg);
	void virtual __fastcall WMSetSubject(TMessage& Msg);
	void virtual __fastcall WMSetMessage(TMessage& Msg);
	void virtual __fastcall WMDelMessage(TMessage& Msg);
	void virtual __fastcall WMTrayIconMessage(TMessage &Msg);
	void virtual __fastcall WMShowStatus(TMessage &Msg);
	void virtual __fastcall WMShowProgress(TMessage &Msg);
	void virtual __fastcall WMProgressError(TMessage &Msg);
	void virtual __fastcall WMUpdateComplete(TMessage &Msg);
	void virtual __fastcall WMMarkMessageRead(TMessage &Msg);
	void virtual __fastcall WMAccountChange(TMessage &Msg);
	void virtual __fastcall WMLogDisplay(TMessage &Msg);
	void virtual __fastcall WMNNTPTimeoutTimer(TMessage &Msg);
	void virtual __fastcall WMMessageBox(TMessage &Msg);
	void virtual __fastcall WMSaveDatabase(TMessage &Msg);
	void virtual __fastcall WMDelNNTPThread(TMessage &Msg);
	void virtual __fastcall WMReplyMessage(TMessage &Msg);
	void virtual __fastcall WMFewerHeaders(TMessage &Msg);
	// message map
	BEGIN_MESSAGE_MAP
	//MESSAGE_HANDLER(WM_LOADPREVIEW, TMessage, WMLoadPreview)
	MESSAGE_HANDLER(WM_SHOWSTATUS, TMessage, WMShowStatus)
	MESSAGE_HANDLER(WM_SHOWPROGRESS, TMessage, WMShowProgress)
	MESSAGE_HANDLER(WM_PROGRESSERROR, TMessage, WMProgressError)
	//MESSAGE_HANDLER(WM_SAVEPROFILE, TMessage, WMSaveProfile)
	MESSAGE_HANDLER(WM_SAVEMESSAGE, TMessage, WMSaveMessage)
	MESSAGE_HANDLER(WM_SETSUBJECT, TMessage, WMSetSubject)
	MESSAGE_HANDLER(WM_SETMESSAGE, TMessage, WMSetMessage)
	MESSAGE_HANDLER(WM_DELMESSAGE, TMessage, WMDelMessage)
	MESSAGE_HANDLER(WM_MARKMESSAGEREAD, TMessage, WMMarkMessageRead)
	MESSAGE_HANDLER(WM_UPDATECOMPLETE, TMessage, WMUpdateComplete)
	MESSAGE_HANDLER(WM_ACCOUNTCHANGE, TMessage, WMAccountChange)
	MESSAGE_HANDLER(WM_TRAYICONMESSAGE, TMessage, WMTrayIconMessage)
	MESSAGE_HANDLER(WM_LOGDISPLAY, TMessage, WMLogDisplay)
	MESSAGE_HANDLER(WM_NNTPTIMEOUTTIMER, TMessage, WMNNTPTimeoutTimer)
	MESSAGE_HANDLER(WM_MESSAGEBOX, TMessage, WMMessageBox)
	MESSAGE_HANDLER(WM_SAVEDATABASE, TMessage, WMSaveDatabase)
	MESSAGE_HANDLER(WM_DELNNTPTHREAD, TMessage, WMDelNNTPThread)
	MESSAGE_HANDLER(WM_REPLYMESSAGE, TMessage, WMReplyMessage)
	MESSAGE_HANDLER(WM_FEWERHEADERS, TMessage, WMFewerHeaders)
	END_MESSAGE_MAP(TForm)
};

const int keyDate = 0;
const int keySubjectOrg = 1;
const int keySize = 2;
const int keyWho = 3;
const int keyMsgNo = 4;
const int keySubject = 5;
const int keySubNo = 6;
const int keyUserID = 7;

bool __fastcall CheckNotifyQSLClipboardOrCopyData(TForm *Owner, TStrings *msg);
bool __fastcall CheckNotifyQSLClipboard(TForm *Owner, TStrings *msg);
void __fastcall CompactMessageHeaders(TStrings *msg);
bool __fastcall NeedsDecryptVerify(TStrings *msg);
//---------------------------------------------------------------------------
extern PACKAGE TQSAMainWin *QSAMainWin;
//---------------------------------------------------------------------------
#endif
