//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "nymserverdlgs.h"
#include "utility.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TNymserverDlg *NymserverDlg;
int modeEdit = 1;
int modeAdd  = 0;
//---------------------------------------------------------------------------

bool __fastcall NewNymserver(TForm *Owner, TStrings *Server, TStrings *Existing)
{
   Server->Clear();
   TNymserverDlg *srvdlg = new TNymserverDlg(Owner);
   srvdlg->existing = Existing;
   srvdlg->mode = modeAdd;
   srvdlg->ShowModal();
   bool ok = srvdlg->ModalResult == mrOk;
   if (ok)
   {
	  AnsiString type = srvdlg->Ghio->Checked ? "ghio" : "zax";
	  Server->Values["server"] = srvdlg->Domain->Text;
	  Server->Values["type"] = type;
	  if (type == "ghio")
		 Server->Values["enckey"] = srvdlg->GetEncryptKey();
   }
   delete srvdlg;
   return ok;
}
//---------------------------------------------------------------------------

/*bool __fastcall NewNymserver(TForm *Owner, AnsiString &Nymserver, AnsiString &Type,
   TStrings *Existing)
{
   TNymserverDlg *srvdlg = new TNymserverDlg(Owner);
   srvdlg->existing = Existing;
   srvdlg->mode = modeAdd;
   srvdlg->ShowModal();
   bool ok = srvdlg->ModalResult == mrOk;
   if (ok)
   {
	  Type = srvdlg->Ghio->Checked ? "ghio" : "zax";
	  Nymserver = srvdlg->Domain->Text;
   }
   delete srvdlg;
   return ok;
}*/
//---------------------------------------------------------------------------

bool __fastcall EditNymserver(TForm *Owner, TStrings *Server)
{
   TNymserverDlg *srvdlg = new TNymserverDlg(Owner);
   AnsiString type = Server->Values["type"].LowerCase();
   srvdlg->Domain->Text = Server->Values["server"];
   srvdlg->Zax->Checked = type == "zax";
   if (type == "ghio")
	  srvdlg->SetEncryptKey(Server->Values["enckey"]);
   srvdlg->mode = modeEdit;
   srvdlg->ShowModal();
   bool ok = srvdlg->ModalResult == mrOk;
   if (ok)
   {
	  Server->Clear();
	  type = srvdlg->Ghio->Checked ? "ghio" : "zax";
	  Server->Values["server"] = srvdlg->Domain->Text;
	  Server->Values["type"] = type;
	  if (type == "ghio")
		 Server->Values["enckey"] = srvdlg->GetEncryptKey();
   }
   delete srvdlg;
   return ok;
}
//---------------------------------------------------------------------------

/*bool __fastcall EditNymserver(TForm *Owner, const AnsiString &Nymserver,
   AnsiString &Type)
{
   TNymserverDlg *srvdlg = new TNymserverDlg(Owner);
   srvdlg->Zax->Checked = Type.LowerCase() == "zax";
   srvdlg->Domain->Text = Nymserver;
   srvdlg->mode = modeEdit;
   srvdlg->ShowModal();
   bool ok = srvdlg->ModalResult == mrOk;
   if (ok)
   {
	  Type = srvdlg->Ghio->Checked ? "ghio" : "zax";
   }
   delete srvdlg;
   return ok;
}*/
//---------------------------------------------------------------------------

__fastcall TNymserverDlg::TNymserverDlg(TComponent* Owner)
	: TForm(Owner)
{
   Domain->Clear();
   TIniFile *ini = new TIniFile(AppIni());
   AssignFont(Font, ini->ReadString("settings", "dialogfont", OptsDefDialogFont));
   AssignFont(Domain->Font, ini->ReadString("settings", "windowfont",
	  OptsDefWindowFont));
   delete ini;
}
//---------------------------------------------------------------------------

void __fastcall TNymserverDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult == mrOk)
   {
	  if (Domain->Text.IsEmpty())
	  {
		 MsgBox(this,
			"The nymserver domain is a required field.   ",
			 MT_INFO, MB_OK);
		 CanClose = false;
		 return;
	  }
	  if (Domain->Text.Pos(".") == 0)
	  {
		 MsgBox(this,
			"The nymserver domain is not valid. I can't find a single   \n"
			"period (.) among the characters!   ",
			 MT_INFO, MB_OK);
		 CanClose = false;
		 return;
	  }
	  if (mode == modeAdd)
	  {
		 if (existing->Values[Domain->Text] != "")
		 {
			MsgBox(this,
			   "Sorry, this nymserver already exists!   ",
				MT_INFO, MB_OK);
			ActiveControl = Domain;
			Domain->Text = "";
			CanClose = false;
			return;
		 }
	  }
   }
}
//---------------------------------------------------------------------------

void __fastcall TNymserverDlg::FormShow(TObject *Sender)
{
   if (mode == modeEdit)
   {
	  Domain->ParentColor = true;
	  Domain->ReadOnly = true;
	  Domain->TabStop = false;
	  ActiveControl = Ghio->Checked ? Ghio : Zax;
   }
   TypeClick(NULL);
}
//---------------------------------------------------------------------------

void __fastcall TNymserverDlg::TypeClick(TObject *Sender)
{

	if (Ghio->Checked)
	{
	   Label4->Enabled = true;
	   Label5->Enabled = true;
	   DES3->Enabled = true;
	   CAST->Enabled = true;
	   IDEA->Enabled = true;
	}
	else
	{
	   Label4->Enabled = false;
	   Label5->Enabled = false;
	   DES3->Enabled = false;
	   CAST->Enabled = false;
	   IDEA->Enabled = false;
	}
}
//---------------------------------------------------------------------------

AnsiString __fastcall TNymserverDlg::GetEncryptKey()
{
   if (DES3->Checked) return "3DES";
   if (CAST->Checked) return "CAST";
   return "IDEA";
}
//---------------------------------------------------------------------------

void __fastcall TNymserverDlg::SetEncryptKey(const AnsiString &value)
{
   if (value == "3DES") DES3->Checked = true; else
   if (value == "CAST") CAST->Checked = true; else
   IDEA->Checked = true;
}
//---------------------------------------------------------------------------

