/*
*  optionsdlgs.h 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver AAM grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#ifndef optionsdlgsH
#define optionsdlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
bool __fastcall ManageProgramOptions(TForm *Owner);

class TOptionsDlg : public TForm
{
__published:	// IDE-managed Components
	TPageControl *PageControl;
	TTabSheet *TabSheet1;
	TPanel *Panel1;
	TButton *OkBtn;
	TButton *CancelBtn;
	TTabSheet *FontSheet;
	TPanel *Panel2;
	TPanel *Panel8;
	TLabel *WinFont;
	TPanel *Panel7;
	TLabel *EdiFont;
	TPanel *Panel6;
	TLabel *DlgFont;
	TButton *EditorFontBtn;
	TLabel *Label11;
	TButton *WindowFontBtn;
	TLabel *Label10;
	TButton *DialogFontBtn;
	TLabel *Label9;
	TCheckBox *UseTrayBox;
	TCheckBox *CheckMailBox;
	TEdit *Minutes;
	TLabel *Label1;
	TUpDown *UpDown1;
	TGroupBox *GroupBox1;
	TCheckBox *HideAcctBox;
	TCheckBox *HidePrxyBox;
	TFontDialog *FontDialog;
	TLabel *Label2;
	TEdit *Lines;
	TTabSheet *TabSheet2;
	TPanel *Panel3;
	TLabel *Label3;
	TEdit *PgpCacheMinutes;
	TUpDown *UpDown2;
	TLabel *Label4;
	TUpDown *UpDown3;
	TLabel *Label5;
	TCheckBox *SaveDecrypted;
	TButton *ClearBtn;
	TLabel *Label6;
	TButton *HelpBtn;
	TCheckBox *Notify;
	TCheckBox *MaskBox;
	TTabSheet *TabSheet3;
	TPanel *Panel4;
	TEdit *NNTPEdit;
	TLabel *Label7;
	TUpDown *NNTPTimeOut;
	TLabel *Label8;
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall DialogFontBtnClick(TObject *Sender);
	void __fastcall WindowFontBtnClick(TObject *Sender);
	void __fastcall EditorFontBtnClick(TObject *Sender);
	void __fastcall CheckMailBoxClick(TObject *Sender);
	void __fastcall ClearBtnClick(TObject *Sender);
	void __fastcall HelpBtnClick(TObject *Sender);
	void __fastcall NNTPEditExit(TObject *Sender);
private:	// User declarations
public:		// User declarations
    int orgtimeout;
	short orgcheckmins, orgcachemins, orgmaxlines;
	bool orgusetray, orgcheckmail, orghideprxy, orghideacct, orgsavedecrypt,
	   orgnotify, orgmaskbox;
	AnsiString orgdlgfont, orgwinfont, orgedifont, newdlgfont, newwinfont, newedifont;
	__fastcall TOptionsDlg(TComponent* Owner);
	__fastcall virtual ~TOptionsDlg();
	bool __fastcall Modified();
};
//---------------------------------------------------------------------------
extern PACKAGE TOptionsDlg *OptionsDlg;
//---------------------------------------------------------------------------
#endif
