/*
*  pgpdlgs.h 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
*
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or
*  combining it with CodeGear VCL (or a modified version of that library),
*  containing parts covered by the terms of CodeGear's license, the licensors
*  of QuickSilver AAM grant you additional permission to convey the
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#ifndef pgpdlgsH
#define pgpdlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include "global.h"
#include "secdbs.h"
//---------------------------------------------------------------------------
bool __fastcall DecryptNymMessage(TForm *Owner, TStrings *lines);
bool __fastcall DecryptMessage(TForm *Owner, TStrings *lines);
bool __fastcall DecryptSymmetric(TForm *Owner, TStrings *lines, AnsiString &passphrase);

class TPgpDlg : public TForm
{
__published:	// IDE-managed Components
	TLabel *Label1;
	TTimer *Timer1;
	void __fastcall FormShow(TObject *Sender);
	void __fastcall Timer1Timer(TObject *Sender);
private:	// User declarations
public:		// User declarations
	int mode;
	bool ok, cancel;
	TStringList *lines;
	TStrings *msgkeys;
	AnsiString passphrase, subno;
	__fastcall TPgpDlg(TComponent* Owner);
	__fastcall virtual ~TPgpDlg();
	bool __fastcall DecryptMessage(TStrings *Lines);
	bool __fastcall DecryptNymMessage(TStrings *Lines);
	bool __fastcall DecryptSymmetric();
	void __fastcall VerifyMessageUserSignature(TStrings *Lines);
	void __fastcall CheckReportBlendAttack(const AnsiString &subno, const AnsiString &keyid);
	int  __fastcall OwnerPerform(UINT Msg, WPARAM wParam, LPARAM lParam);
	void __fastcall ShowStatus(const AnsiString &msg);
	TForm* __fastcall OwnerForm();
};

void __fastcall StripSymmetricDecryptionMarkers(TStrings *lines);

//---------------------------------------------------------------------------
extern PACKAGE TPgpDlg *PgpDlg;
//---------------------------------------------------------------------------
#endif
