/*
*  subjectsdlgs.h 
*
*  Copyright (C) 2012 Richard Christman 
*
*  This file is part of QuickSilver AAM.
*
*  QuickSilver AAM is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver AAM, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver AAM grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------

#ifndef subjectsdlgsH
#define subjectsdlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
bool __fastcall CreateSubjectPassphrasePair(TForm *Owner, AnsiString &SubAndPass, TStrings *Existing);
bool __fastcall EditSubjectPassphrasePair(TForm *Owner, AnsiString &SubAndPass, TStrings *Existing);

class TSubjectsDlg : public TForm
{
__published:	// IDE-managed Components
	TCheckBox *HideBox1;
	TButton *OkBtn;
	TButton *CancelBtn;
	TBevel *Bevel1;
	TEdit *Subject;
	TLabel *Label3;
	TLabel *Label4;
	TCheckBox *EncryptSub;
	TLabel *Label1;
	TCheckBox *Active;
	TEdit *SubPhrase;
	TLabel *Label2;
	TEdit *KeyPhrase;
	TCheckBox *HideBox2;
	TLabel *Label5;
	TCheckBox *EncryptKey;
	TLabel *Label6;
	TLabel *Label7;
	TComboBox *PGPKey;
	TLabel *Label8;
	TButton *HelpBtn;
	void __fastcall SubjectChange(TObject *Sender);
	void __fastcall PhraseChange(TObject *Sender);
	void __fastcall HideBox1Click(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall EncryptSubClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall SubPhraseEnter(TObject *Sender);
	void __fastcall HideBox2Click(TObject *Sender);
	void __fastcall KeyPhraseEnter(TObject *Sender);
	void __fastcall EncryptKeyClick(TObject *Sender);
	void __fastcall ActiveClick(TObject *Sender);
	void __fastcall HelpBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
	TColor EditColor;
	AnsiString subandpass, orgsubphrase, orgkeyphrase, orgsubject, orgkeyid, subno;
	bool orgencrypt, orgactive;
	TStringList *existing, *data;
	__fastcall TSubjectsDlg(TComponent* Owner);
	__fastcall virtual ~TSubjectsDlg();
	void __fastcall LoadKeys(const AnsiString &KeyID);
   	//void __fastcall AddExisting(const AnsiString &SubAndPass, TStrings *Existing);
	bool __fastcall SubjectExists(const AnsiString &Subject, const AnsiString &EPhrase);
	void __fastcall SetSubAndPass(const AnsiString &Subject, TStrings *Existing);
	AnsiString __fastcall GetSubAndPass();
	AnsiString __fastcall GetSelectedKeyID();
	bool __fastcall Modified();
};

//---------------------------------------------------------------------------
extern PACKAGE TSubjectsDlg *SubjectsDlg;
//---------------------------------------------------------------------------
#endif
